



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SpringMVC从入门到精通之第四章</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SpringMVC从入门到精通之第四章</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 08:00:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>第一个知识点：@Controller注解，用于标识这个类是一个后端控制器（类似struts中的action）,<br />主要作用就是接受页面的参数，转发页面。<br />中间的业务逻辑是调用业务类处理的这个就是MVC设计模式的思路。<br />我们来看下这个注解的源码：</p>
<div>
<pre class="prettyprint linenums">package org.springframework.stereotype;

import java.lang.annotation.Annotation;<br />
import java.lang.annotation.Documented;<br />
import java.lang.annotation.Retention;<br />
import java.lang.annotation.RetentionPolicy;<br />
import java.lang.annotation.Target;<br />
// 表明只能定义在类上面<br />
@Target({java.lang.annotation.ElementType.TYPE})<br />
//保留策略是RUNTIME，在JVM加载类时，会把注解加载到JVM内存中（它是唯一可以用反射来读取注解的策略）<br />
@Retention(RetentionPolicy.RUNTIME)<br />
//@Documented用于描述其它类型的annotation应该被作为被标注的程序成员的公共API，因此可以被例如javadoc此类的工具文档化。Documented是一个标记注解，没有成员。<br />
@Documented<br />
//spring框架规定当一个类不好归类（service、dao、controller）的时候可以使用这个注解，由此可见即便好归类内部还是使用的@Component注解<br />
@Component<br />
public @interface Controller<br />
{<br />
  public abstract String value();//默认值可以是组件名称，一般不写（看上面英文解释）<br />
}</pre>
</div>
<p>第二个知识点：@RequestMapping注解，同上面一样，这个注解的作用目标就跟@Controller不一样了，这个注解可以定义在类上面也可以定义在方法上面。</p>
<p>例如：</p>
<div>
<pre class="prettyprint linenums">import org.springframework.stereotype.Controller;<br />
import org.springframework.web.bind.annotation.RequestMapping;

@Controller<br />
@RequestMapping("/springmvc")<br />
public class Test01_RequestMapping {<br />
    /**<br />
     * 1.@RequestMapping :除了修饰方法,还可以修饰类 *<br />
     * 2.类定义处：提供初步的请求信息映射.相对于WEB应用的根目录(窄化请求) * 3.方法处：提供进一步的细分映射信息。相对于类定义处的URL。 *<br />
     * 若类定义处为标注@RequestMapping,则方法出的URL相对于WEB应用的根目录 * @return<br />
     */<br />
    @RequestMapping("/testRequestMapping")<br />
    public String testRequestMapping() {<br />
        System.out.println("@RequestMapping注解的作用目标");<br />
        return "success";<br />
    }<br />
}</pre>
</div>
<p>来看一下注解的源码说明：</p>
<div>
<pre class="prettyprint linenums">@Target({ElementType.METHOD, ElementType.TYPE})<br />
@Retention(RetentionPolicy.RUNTIME)<br />
@Documented<br />
@Mapping<br />
public @interface RequestMapping {<br />
    String[] value() default {};//默认值可以是多个<br />
    RequestMethod[] method() default {};//限制请求方式<br />
    String[] params() default {};//要求请求的URL包含指定的参数<br />
    。。。<br />
}</pre>
</div>
<p>示例代码：</p>
<div>
<pre class="prettyprint linenums">/*<br />
     * @Title: testRequestMappingAttrMethodPost<br />
     * @Description: TODO (限制请求方式只能是POST请求)<br />
     * @return<br />
     */<br />
    @RequestMapping(value = "/testRequestMappingAttrMethodPost", method = { RequestMethod.POST })<br />
    public String testRequestMappingAttrMethodPost() {<br />
        System.out.println("@RequestMaping注解的属性：method RequestMethod[]{RequestMethod.POST}");<br />
        return "success";<br />
    }

    /**<br />
     * @Title: testRequestMappingAttrMethodGet<br />
     * @Description: TODO (限制请求方式只能是GET请求)<br />
     * @return *<br />
     */<br />
    @RequestMapping(value = "/testRequestMappingAttrMethodGet", method = { RequestMethod.GET })<br />
    public String testRequestMappingAttrMethodGet() {<br />
        // 请求url<br />
        // "${pageContext.request.contextPath}/springmvc/testRequestMappingAttrParams?username=hanson&amp;age=11"<br />
        System.out.println("@RequestMaping注解的属性：method RequestMethod[]{RequestMethod.GET}");<br />
        return "success";<br />
    }</pre>
</div>
<p>这个注解还支持Ant风格的请求：</p>
<div>
<pre class="prettyprint linenums">Ant风格资源地址支持3种匹配符：<br />
?：匹配文件中的一个字符<br />
*：匹配文件中任意字符<br />
**：**匹配多层路径<br />
@RequestMapping 支持 Ant 风格的 URL ：<br />
/user/*/createUser : 匹配 &ndash;/user/aaa/createUser、/user/bbb/createUser 等 URL<br />
/user/*/createUser : 匹配 &ndash;/user/aaa/createUser、/user/bbb/createUser 等 URL<br />
/user/**/createUser : 匹配 &ndash;/user/createUser、/user/aaa/bbb/createUser 等 URL<br />
/user/createUser?? : 匹配 &ndash;/user/createUseraa、/user/createUserbb 等 URL</pre>
</div>
<p>例如：下面这种请求：<br />href="${pageContext.request.contextPath}/springmvc/testAntStyleURL/ccccc/abc"<br />示例代码：</p>
<div>
<pre class="prettyprint linenums">@RequestMapping("testAntStyleURL/*/abc")<br />
     public String testAntStyleURL(){<br />
         System.out.println("AntStyleURL:testAntStyleURL/*/abc");<br />
         return "success";<br />
    }</pre>
</div>
<div>学完这一章你应该知道@Controller注解的作用范围，表示的类是一个后端控制器。<br />
@RequestMapping注解的作用范围，在类上和在目标方法上的区别以及作用，以及能够限制请求方式等。<br />作者：<br />
            HansonQ<br />
            <br />链接：http://www.imooc.com/article/4299<br />来源：慕课网</div>
<p>学完这一章你应该知道@Controller注解的作用范围，表示的类是一个后端控制器。<br />@RequestMapping注解的作用范围，在类上和在目标方法上的区别以及作用，以及能够限制请求方式等。</p>
<p><a href="http://www.cnblogs.com/kevin1990/p/6117101.html" rel="external nofollow noreferrer">SpringMVC从入门到精通第三章</a></p>
<p>作者： HansonQ<br />链接：http://www.imooc.com/article/4299<br />来源：慕课网</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxe75e8.html">C语言-预估校正法求常微分方程</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1yo05q.html">WindowsPhone技术和XNA技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2w0z8.html">CSS3入门之边框与背景</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2mxe8.html">oracle中的sql&percnt;rowcount&comma;sql&percnt;found、sql&percnt;notfound、sql&percnt;rowcount和sql&percnt;isopen</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzolj8.html">输入n个整数，输出其中最小的k个</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96r7d49.html">JDK源码调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e10k0m9.html">Data Base  MongoDB   插入时间不正确的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvr5l1q.html">查看SQL Server 备份信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zy3269.html">浅析 public static void main&lpar;String&lbrack;&rsqb; args&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xnl5m8.html">浅析JAVA设计模式（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm66oe9.html">Git的一些用法&lpar;建立新的branch&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yndlz8.html">perl open函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp45479.html">POJ 2253 Frogger（Dijkstra变形&mdash;&mdash;最短路径最大权值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozolg8.html">LeetCode 145&period; Binary Tree Postorder Traversal 二叉树的后序遍历 C&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyryen9.html">Tomcat 启动时 警告&colon; &lbrack;SetPropertiesRule&rsqb;&lbrace;Server&sol;Service&sol;Engine&sol;Host&sol;Context&rcub;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjgny59.html">CSS选择符-----属性选择符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvo3628.html">错误：php70w-common conflicts with php-common-5&period;3&period;3-49&period;el6&period;i686</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv1252q.html">使用cat读取和echo写内核文件节点的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvekpoz9.html">指定nginx某个目录显示目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4o1vxq.html">【LOJ】&num;2674&period; 「NOI2012」美食节</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jdon49.html">今天做项目时，用到了好多关于js的知识点，有的忘记了，然后晚上回来自己整理一番，明天继续整理。哈哈，分享给大家。</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96zrlnq.html">使用coding、daocloud和docker打造markdown纯静态博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8erv5jq.html">Typecast 免费了！献给设计师们的礼物</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96zeznq.html">InstantClick &ndash; 快速响应！让你的网站与众不同</a>
			</li>
						<li><a href="https://www.batexi.com/a/49grokzq.html">asp&period;net正则模板引擎代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxzpxj8.html">JavaScript技巧&lbrack;转载&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zem4v8.html">从angularJS看MVVM</a>
			</li>
						<li><a href="https://www.batexi.com/a/49grl6zq.html">使用 SQL的 for xml path来进行字符串拼接 &lpar;group by&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rkj5dq.html">centos初始配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o2n7e9.html">linux 系统权限 数字含义</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
